use std::io;

use plugins::Plugin;
use toml::Table;

use User;

use std::sync::mpsc::Sender;
use event::Event;

pub struct StdinPlugin {}

impl StdinPlugin {
    pub fn new (configuration: &Table) -> Box<Plugin> {
        Box::new(StdinPlugin {})
    }
}

impl Plugin for StdinPlugin {
    fn produce_events<'a>(&'a self, sender: Sender<Event>) {
        let user = User {
            name: String::from("Dave"),
            send_function: &(|user: &User, message: &str| {
                println!("Send to {:?}: {:?}", user.name, message);
            })
        };

        loop {
            let mut input = String::new();
            match io::stdin().read_line(&mut input) {
                Ok(n) => {
                    let message = Event::Message { sender: user.clone(), content: input, channel: None };
                    sender.send(message);
                }
                Err(error) => println!("error: {}", error),
            }
        }
    }
}
